/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
void kmpMini::init() 
{
    popMenu = new QPopupMenu;
    popMenu->setCheckable(TRUE);
    popMenu->insertItem("Random", this, SIGNAL(toggleRandom()));
    popMenu->insertItem("Repeat", this, SIGNAL(toggleRepeat())); 
    popMenu->insertSeparator();
    popMenu->insertItem("Connect", this, SIGNAL(showConnect()));
    popMenu->insertItem("Options", this, SIGNAL(showOptions()));
    popMenu->insertItem("About", this, SIGNAL(showAbout()));
    popMenu->insertSeparator();
    popMenu->insertItem("Playlist", this, SIGNAL(togglePlaylist()));
    popMenu->insertItem("Browse", this, SIGNAL(toggleBrowse()));
    popMenu->insertSeparator();
    popMenu->insertItem("Expand", this, SIGNAL(toggleWindow()));
    popMenu->insertSeparator();
    popMenu->insertItem("Quit", this, SIGNAL(kill()));
    
    icons * MyIcons;
    MyIcons = new icons;
    playIcon = MyIcons->playI;
    pauseIcon = MyIcons->pauseI;
    
   
    
    delete MyIcons;
    btn_playpause->setPixmap(playIcon);
    
    //*******scrollLoop********
    //Create the Timer
    QTimer* scrollLoop = new QTimer(this);
    //Start the timer, with interval at 100ms (MIGHT ADD ABILITY TO CHANGE THIS)
    scrollLoop->start(100);
    //connect the scrollLoop timeout with the slot to move the main scrolling title
    //so that we will have a smooth scrolling title bar
    connect(scrollLoop, SIGNAL(timeout()), this, SLOT(ScrollIncrement()));
    //*************************

    progressPause = FALSE;
    showFilenameOnly = FALSE;
    
}



//Name:  Scroll Increment()
//When&What Calls:  This is called by the scrolltimer every 100ms
//Purpose:  To have the main title bar scroll when needed
void kmpMini::ScrollIncrement()
{
    if( mainFrame->width()  != width() -4)
    {
	mainFrame->setMaximumWidth(width() - 3);
    }
    
    //First we check if the text in the bar has changed
    if(ChangedMainBar) {
	//If the main bar has been changed, we must:
	//    1)reset the scrolling direction
	ScrollDirection = -1;
	//    2)reset the size of the bar to fit the text EXACTLY
	mainBar->setGeometry(0,-1,QFontMetrics(mainBar->font()).width(mainBar->text()), 20);
	//    3)reset the variable, so we don't keep fixing the main bar
	ChangedMainBar = FALSE;
    } else {
	//If we HAVEN'T changed the bar, we do the normal scrolling operations
	//  if we are at the end of the scroll, we pause for 2 seconds (20 100ms intervals)
	if(pauseScroll ) {
	    //Next we check to see if we have finished our pause
	    if(countForPause++ > 20) pauseScroll=FALSE;
	    //   if we haven't exit this function
	         else return;
	 }
	//Next we get the size of the main bar, so we know how big it is
	//	and thus how far we need to move it to see all of it
	QRect GetRect = mainBar->geometry();
	//If the size of the text is SMALLER then the size of the viewable area
	//	(around 317 pixels) then exit the function, no scrolling needed
	QRect frameRect = mainFrame->geometry();
	
	if(GetRect.width() < frameRect.width() - 3) {
	    if(GetRect.left() != 2) mainBar->setGeometry(0,-1,QFontMetrics(mainBar->font()).width(mainBar->text()), 20);
	    return;
	}
	//Otherwise set the new spot for the main bar
	GetRect.setLeft(GetRect.left() + ScrollDirection * 2);
	GetRect.setWidth(GetRect.width() + ScrollDirection * 2);
	//Then make these changes to the widget
	//mainBar->setMaximumSize(QSize(GetRect.height(), GetRect.width()));
	mainBar->setGeometry(GetRect);
	//Then we see if the we have reached an end
	if((GetRect.left() + GetRect.width() < frameRect.width() - 3) || GetRect.left() > 0) {
	    //If we have reached an end, start the scroll pause
	    countForPause = 0;
	    pauseScroll = TRUE;
	    //And change the direction of the scroll
	    ScrollDirection = ScrollDirection * (-1);
	}
    }
}

void kmpMini::update( int songTime)
{


    if(songTime == -1) songTime =0;
   
    //Next we check to see if we should not update the widget
    //	this is normally when the user is dragging on the position
    //	of the song to seek.
    if(curSongLen != 0) {
	    //Also used to see if a song is loaded (or avaible to get info
	    //	time info on
	    //Now we get the current position of the status bar (which
	    //	has 1000 intervals on it, so we multiply the % 
	    //	complete of the song by 1000 to get which interval
	    //	it should be on)
	QToolTip::add( mainBar, tooltip(curSongStore, songTime));
	int currentPos = (int)(1000 * ((double)songTime / (double)curSongLen));
	if(!progressPause) progressBar->setValue(currentPos);
    }
}





void kmpMini::changeStatus(int status)
{
    btn_prev->setEnabled(status);
    btn_stop->setEnabled(status);
    btn_playpause->setEnabled(status);	    
    btn_next->setEnabled(status);
    progressBar->setEnabled(status);
    popMenu->setItemEnabled(popMenu->idAt(0), status);
    popMenu->setItemEnabled(popMenu->idAt(1), status);    
    if(status == MPD_STATUS_STATE_PLAY) {
	//If we are playing, make the button PAUSE the player
	btn_playpause->setPixmap(pauseIcon);
    } else {
	//If we are not playing, make the button PLAY
	btn_playpause->setPixmap(playIcon);
    }
    //Finally we check to see if we are STOPPED (not paused)
    //	if we are we then set the current progress in the song to 0
    if(status == MPD_STATUS_STATE_STOP) {
	//Set the progress widget to 0 (beginning of a song)
	progressBar->setValue(0);
	mainBar->setText("");
	ChangedMainBar=true;
    }
}

void kmpMini::newSong( mpd_SongStore aSong )
{
    curSongStore = aSong;
    //We set the new values for the song
    curSongLen = aSong.time;
    if(showFilenameOnly) {
	mainbarText = fileTitle(aSong.file);
    } else {
	mainbarText = title(aSong);
    }
		
    //And update this text to the widget
    mainBar->setText(mainbarText);
    //And since we updated the playlist, we need to tell the scroll to
    //	update its information.
    ChangedMainBar = TRUE;
}







void kmpMini::popupMenu( QMouseEvent *e )
{
    popMenu->popup(e->globalPos());
}


void kmpMini::closeEvent( QCloseEvent * a) {
    closed();
    this->hide();
    a->ignore();
}

void kmpMini::prev()
{
    sendPrev();
}
void kmpMini::stop()
{
    sendStop();
}
void kmpMini::play()
{
    sendPlay();
}
void kmpMini::next()
{
    sendNext();
}
void kmpMini::playlist()
{
    togglePlaylist();
}
void kmpMini::browse()
{
    toggleBrowse();
}

void kmpMini::setRandom( bool value )
{
    popMenu->setItemChecked(popMenu->idAt(0), value);
}


void kmpMini::setRepeat( bool value )
{
    popMenu->setItemChecked(popMenu->idAt(1), value);
}

void kmpMini::setBrowseVis(bool on) {
    btn_br->setOn(on);
    popMenu->setItemChecked(popMenu->idAt(6), on);
}

void kmpMini::setPlaylistVis(bool on) {
    btn_pl->setOn(on);
    popMenu->setItemChecked(popMenu->idAt(7), on);
}
void kmpMini::setFilenameOnly( bool value )
{
    showFilenameOnly = value;
}
//Name:  pauseProgress()
//When&What Calls:  This is called when the user Clicks DOWN on the volume bar
//Purpose:  To stop the status from updating the volume and get the intial volume
void kmpMini::pauseProgress()
{
    //by setting this variable to TRUE, we are telling the status to skip over volume when
    //	updating
    progressPause = TRUE;
}

//Name:  unpauseProgress()
//When&What Calls:  this is called when the user lets up on the mouse button
//Purpose:  To send the change volume command to the server
void kmpMini::unpauseProgress()
{
    //We send the server the change volume command
    sendSeek((double)(progressBar->value()) / 1000.0);
    //And by setting this variable to false, we are telling the status updates to resume
    //	updating the bar
    progressPause = FALSE;

}
